import { jsx, jsxs } from 'react/jsx-runtime';
import styled from '@emotion/styled';
import { Formik, Form, Field } from 'formik';

var _assign = function __assign() {
  _assign = Object.assign || function __assign(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return _assign.apply(this, arguments);
};
function __makeTemplateObject(cooked, raw) {
  if (Object.defineProperty) {
    Object.defineProperty(cooked, "raw", {
      value: raw
    });
  } else {
    cooked.raw = raw;
  }
  return cooked;
}

var Container = styled.button(templateObject_1$2 || (templateObject_1$2 = __makeTemplateObject(["\n  &:hover {\n    opacity: 0.8;\n  }\n"], ["\n  &:hover {\n    opacity: 0.8;\n  }\n"])));
var templateObject_1$2;

var defaultStyle$2 = {
  width: '10rem',
  height: '2rem',
  background: 'teal',
  color: 'white',
  fontWeight: 'bold',
  borderRadius: '8px'
};
var Button = function Button(_a) {
  var children = _a.children,
    style = _a.style,
    _b = _a.type,
    type = _b === void 0 ? 'submit' : _b;
  return jsx(Container, _assign({
    style: _assign(_assign({}, defaultStyle$2), style),
    type: type
  }, {
    children: children
  }));
};

var defaultStyle$1 = {
  width: '100%'
};
var FormBox = function FormBox(_a) {
  var style = _a.style,
    _children = _a.children,
    initialValues = _a.initialValues,
    validationSchema = _a.validationSchema,
    onSubmit = _a.onSubmit,
    _b = _a.validateOnChange,
    validateOnChange = _b === void 0 ? true : _b,
    _c = _a.validateOnBlur,
    validateOnBlur = _c === void 0 ? true : _c,
    _d = _a.validateOnMount,
    validateOnMount = _d === void 0 ? true : _d;
  return jsx(Formik, _assign({
    initialValues: initialValues,
    onSubmit: onSubmit,
    validationSchema: validationSchema,
    validateOnBlur: validateOnBlur,
    validateOnChange: validateOnChange,
    validateOnMount: validateOnMount
  }, {
    children: function children(props) {
      return jsx(Form, {
        children: jsx("div", _assign({
          style: _assign(_assign({}, defaultStyle$1), style)
        }, {
          children: _children
        }))
      });
    }
  }));
};

var HStack = styled.div(templateObject_1$1 || (templateObject_1$1 = __makeTemplateObject(["\n  display: flex;\n  justify-content: ", ";\n  align-items: ", ";\n  width: ", ";\n  height: ", ";\n  margin: ", ";\n  padding: ", ";\n  gap: ", ";\n"], ["\n  display: flex;\n  justify-content: ", ";\n  align-items: ", ";\n  width: ", ";\n  height: ", ";\n  margin: ", ";\n  padding: ", ";\n  gap: ", ";\n"])), function (_a) {
  var justifyContent = _a.justifyContent;
  return justifyContent;
}, function (_a) {
  var alignItems = _a.alignItems;
  return alignItems;
}, function (_a) {
  var width = _a.width;
  return width;
}, function (_a) {
  var height = _a.height;
  return height;
}, function (_a) {
  var margin = _a.margin;
  return margin;
}, function (_a) {
  var padding = _a.padding;
  return padding;
}, function (_a) {
  var gap = _a.gap;
  return gap;
});
var VStack = styled.div(templateObject_2$1 || (templateObject_2$1 = __makeTemplateObject(["\n  display: flex;\n  flex-direction: column;\n  justify-content: ", ";\n  align-items: ", ";\n  width: ", ";\n  height: ", ";\n  margin: ", ";\n  padding: ", ";\n  gap: ", ";\n"], ["\n  display: flex;\n  flex-direction: column;\n  justify-content: ", ";\n  align-items: ", ";\n  width: ", ";\n  height: ", ";\n  margin: ", ";\n  padding: ", ";\n  gap: ", ";\n"])), function (_a) {
  var justifyContent = _a.justifyContent;
  return justifyContent;
}, function (_a) {
  var alignItems = _a.alignItems;
  return alignItems;
}, function (_a) {
  var width = _a.width;
  return width;
}, function (_a) {
  var height = _a.height;
  return height;
}, function (_a) {
  var margin = _a.margin;
  return margin;
}, function (_a) {
  var padding = _a.padding;
  return padding;
}, function (_a) {
  var gap = _a.gap;
  return gap;
});
var templateObject_1$1, templateObject_2$1;

var StyledInput = styled.input(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  height: 2rem;\n  width: 100%;\n  border-radius: 8px;\n  padding: 0 0.5rem;\n  font-size: 12px;\n  border: ", ";\n  &:focus-visible {\n    outline: ", ";\n  }\n  background-color: ", ";\n"], ["\n  height: 2rem;\n  width: 100%;\n  border-radius: 8px;\n  padding: 0 0.5rem;\n  font-size: 12px;\n  border: ", ";\n  &:focus-visible {\n    outline: ", ";\n  }\n  background-color: ", ";\n"])), function (_a) {
  var hasError = _a.hasError,
    disabled = _a.disabled;
  return disabled ? '2px solid #757575' : hasError ? '2px solid red' : '2px solid black';
}, function (_a) {
  var hasError = _a.hasError,
    disabled = _a.disabled;
  return disabled ? '1px #757575 auto' : hasError ? '1px red auto' : '1px teal auto';
}, function (_a) {
  var disabled = _a.disabled;
  return disabled ? '#dbdbdb' : '#ffffff';
});
var ErrorMessage = styled.p(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  color: red;\n  font-size: 12px;\n"], ["\n  color: red;\n  font-size: 12px;\n"])));
var templateObject_1, templateObject_2;

var defaultStyle = {
  height: "2rem",
  width: "100%"
};
var Input = function Input(_a) {
  var _b = _a.disabled,
    disabled = _b === void 0 ? false : _b,
    name = _a.name,
    style = _a.style,
    _c = _a.placeholder,
    placeholder = _c === void 0 ? "" : _c;
  return jsx(Field, _assign({
    name: name
  }, {
    children: function children(_a) {
      var field = _a.field;
        _a.form.setFieldValue;
        var _b = _a.meta,
        error = _b.error,
        touched = _b.touched,
        value = _b.value;
      return jsxs(VStack, _assign({
        gap: "0.25rem"
      }, {
        children: [jsx(StyledInput, _assign({}, field, {
          style: _assign(_assign({}, defaultStyle), style),
          value: value,
          hasError: !!touched && !!error,
          disabled: disabled,
          placeholder: placeholder
        })), jsx(ErrorMessage, {
          children: !!touched && error
        })]
      }));
    }
  }));
};

export { Button, FormBox, HStack, Input as Inupt, VStack };
//# sourceMappingURL=bundle.js.map
